package jalview.gui;

import jalview.datamodel.*;
import jalview.jbgui.GPairwiseAlignPanel;
import jalview.analysis.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;


public class PairwiseAlignPanel extends GPairwiseAlignPanel
{
    Vector sequences = new Vector();
    AlignViewport av;

    public PairwiseAlignPanel(AlignViewport av)
    {
      super();
      this.av = av;
      float scores[][] = new float[av.getAlignment().getHeight()][av.getAlignment().getHeight()];
      double totscore = 0;
      int count = av.getSelection().size();

      int acount = 0;
        for (int i = 1; i < count; i++)
        {
          for (int j = 0; j < i; j++)
          {
            acount++;
            AlignSeq as = new AlignSeq(av.getSelection().sequenceAt(i),av.getSelection().sequenceAt(j),"pep");
            //tf.status.setText("Aligning " + as.getS1().getName() + " and " + as.getS2().getName() + " (" + acount + "/" + (count*(count-1)/2) + ")");

            as.calcScoreMatrix();
            as.traceAlignment();
            as.printAlignment();
            scores[i][j] = (float)as.getMaxScore()/(float)as.getASeq1().length;
            totscore = totscore + scores[i][j];

            textarea.append(as.getOutput());
            sequences.add( as.getS1() );
            sequences.add( as.getS2() );

          }
        }

        if (count > 2)
        {
          for (int i = 0; i < count;i++)
            for (int j = 0; j < i; j++)
              jalview.util.Format.print(System.out,"%7.3f",scores[i][j]/totscore);
        }
      }


  protected void viewInEditorButton_actionPerformed(ActionEvent e)
  {

      Sequence [] seq = new Sequence[sequences.size()];

      for (int i=0;i<sequences.size();i++)
       seq[i] = (Sequence) sequences.elementAt(i);


      AlignFrame af = new AlignFrame(new Alignment(seq));
      int newHeight = seq.length * af.viewport.getCharHeight() + 200;
      if(newHeight>500)
        newHeight=500;

      Desktop.addInternalFrame(af, "Pairwise Aligned Sequences", 700,newHeight);

  }

}
